tests/fate.sh
a9dc6111
 #! /bin/sh
 
 config=$1
 
 die(){
     echo "$@"
     exit 1
 }
 
 test -r "$config"  || die "usage: fate.sh <config>"
 
8226e977
 workdir=$(cd $(dirname $config) && pwd)
a9dc6111
 make=make
8b0816cb
 tar='tar c'
a9dc6111
 
 . "$config"
 
 test -n "$slot"    || die "slot not specified"
 test -n "$repo"    || die "repo not specified"
 test -d "$samples" || die "samples location not specified"
 
42eb9154
 : ${branch:=master}
 
a9dc6111
 lock(){
     lock=$1/fate.lock
     (set -C; exec >$lock) 2>/dev/null || return
     trap 'rm $lock' EXIT
 }
 
 checkout(){
     case "$repo" in
         file:*|/*) src="${repo#file:}"      ;;
42eb9154
         git:*)     git clone --quiet --branch "$branch" "$repo" "$src" ;;
a9dc6111
     esac
 }
 
 update()(
     cd ${src} || return
     case "$repo" in
18d8398c
         git:*) git fetch --quiet --force && git reset --quiet --hard "origin/$branch" ;;
a9dc6111
     esac
 )
 
 configure()(
     cd ${build} || return
d2a47c94
     ${shell} ${src}/configure                                           \
a9dc6111
         --prefix="${inst}"                                              \
         --samples="${samples}"                                          \
74c847e0
         --enable-gpl                                                    \
7c84e7d3
         --enable-memory-poisoning                                       \
2ea60971
         --enable-avresample                                             \
a9dc6111
         ${arch:+--arch=$arch}                                           \
         ${cpu:+--cpu="$cpu"}                                            \
f01c7715
         ${toolchain:+--toolchain="$toolchain"}                          \
a9dc6111
         ${cross_prefix:+--cross-prefix="$cross_prefix"}                 \
d7b9b66a
         ${as:+--as="$as"}                                               \
a9dc6111
         ${cc:+--cc="$cc"}                                               \
2b366008
         ${ld:+--ld="$ld"}                                               \
a9dc6111
         ${target_os:+--target-os="$target_os"}                          \
         ${sysroot:+--sysroot="$sysroot"}                                \
         ${target_exec:+--target-exec="$target_exec"}                    \
         ${target_path:+--target-path="$target_path"}                    \
ba13606c
         ${target_samples:+--target-samples="$target_samples"}           \
a9dc6111
         ${extra_cflags:+--extra-cflags="$extra_cflags"}                 \
         ${extra_ldflags:+--extra-ldflags="$extra_ldflags"}              \
         ${extra_libs:+--extra-libs="$extra_libs"}                       \
         ${extra_conf}
 )
 
 compile()(
     cd ${build} || return
     ${make} ${makeopts} && ${make} install
 )
 
 fate()(
c209d0df
     test "$build_only" = "yes" && return
a9dc6111
     cd ${build} || return
     ${make} ${makeopts} -k fate
 )
 
673fe599
 clean(){
20e1829d
     rm -rf ${build} ${inst}
673fe599
 }
 
a9dc6111
 report(){
     date=$(date -u +%Y%m%d%H%M%S)
7ad27f12
     echo "fate:1:${date}:${slot}:${version}:$1:$2:${branch}:${comment}" >report
d554d004
     cat ${build}/config.fate >>report
89790ba2
     cat ${build}/tests/data/fate/*.rep >>report || for i in ${build}/tests/data/fate/*.rep ; do cat "$i" >>report 2>/dev/null; done
8b0816cb
     test -n "$fate_recv" && $tar report *.log | gzip | $fate_recv
a9dc6111
 }
 
 fail(){
     report "$@"
51124db8
     clean
a9dc6111
     exit
 }
 
 mkdir -p ${workdir} || die "Error creating ${workdir}"
 lock ${workdir}     || die "${workdir} locked"
 cd ${workdir}       || die "cd ${workdir} failed"
 
 src=${workdir}/src
eb8da636
 : ${build:=${workdir}/build}
 : ${inst:=${workdir}/install}
a9dc6111
 
 test -d "$src" && update || checkout || die "Error fetching source"
 
 cd ${workdir}
 
 version=$(${src}/version.sh ${src})
32a15a24
 test "$version" = "$(cat version-$slot 2>/dev/null)" && exit 0
 echo ${version} >version-$slot
a9dc6111
 
69a9c80b
 rm -rf "${build}" *.log
a9dc6111
 mkdir -p ${build}
 
cc0057a3
 configure >configure.log 2>&1 || fail 3 "error configuring"
 compile   >compile.log   2>&1 || fail 2 "error compiling"
 fate      >test.log      2>&1 || fail 1 "error testing"
a9dc6111
 report 0 success
673fe599
 clean